LeetCode #235 Lowest Common Ancestor of a Binary Search Tree
Problem
Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.
According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes p and q as the lowest node in T that has both p and q as descendants (where we allow a node to be a descendant of itself).”
Given binary search tree: root = [6,2,8,0,4,7,9,null,null,3,5]
_______6______
/ \
___2__ ___8__
/ \ / \
0 _4 7 9
/ \
3 5
Example 1:
Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
Output: 6
Explanation: The LCA of nodes 2 and 8 is 6.
Example 2:
Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
Output: 2
Explanation: The LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself
according to the LCA definition.w
Note:
- All of the nodes’ values will be unique.
- p and q are different and both values will exist in the BST.
Solution
By comparing with root, p and q, we can decide next root or just return root as result.
Complexity
Because we move current
from root to a leaf. It’s time complexity will be O(h) if h
denotes to the length of longest path from root to leaves in this tree. Or you can say O(logn) because h
is bounded by logn
.
It’s trivial that it uses O(1) extra space.